﻿using UnityEngine;
using System.Collections;

public class FallingPlatform : MonoBehaviour {

	public Rigidbody target;

	public float waitTime = 1;

	private Vector3 startPosition;

	void Start () {
		startPosition = transform.position;
	}

	void Update () {
		if (SceneState.Instance.respawn) {
			transform.position = startPosition;
			target.isKinematic = true;
		}
	}

	void OnTriggerEnter(Collider other)
	{
		if (other.tag == "Player") {
			StartCoroutine (Fall());
		}
	}

	IEnumerator Fall()
	{
		yield return new WaitForSeconds (waitTime);

		target.isKinematic = false;
	}
}
