﻿using UnityEngine;
using UnityEngine.Events;
using System.Collections;


[RequireComponent(typeof(SpriteRenderer))]
public class Fog : MonoBehaviour
{

    [Range(0, 1)] [SerializeField] private float maxOpacity = .8f;
    [SerializeField] private float maxOpacityRange = 10f;
    [SerializeField] private float minOpacityRange = 1;

    private SpriteRenderer spriteRenderer;

    void Start()
    {
        spriteRenderer = GetComponent<SpriteRenderer>();
    }

    void Update()
    {
        float zDistance = transform.position.z - Camera.main.transform.position.z;
        zDistance = Mathf.Max(minOpacityRange, zDistance);
        zDistance = Mathf.Min(maxOpacityRange, zDistance);
        Color color = spriteRenderer.color;
        color.a = (zDistance - minOpacityRange) / (maxOpacityRange - minOpacityRange) * maxOpacity;
        spriteRenderer.color = color;
    }


}
