using System;
using UnityEngine;
using UnityStandardAssets.CrossPlatformInput;

namespace UnityStandardAssets._2D
{
    [RequireComponent(typeof(PlatformerCharacter2D))]
    public class Platformer2DUserControl : MonoBehaviour
    {
        private PlatformerCharacter2D m_Character;
        private PlatformDepth platformDepth;
        private Push push;
        private Gun gun;
        private bool m_Jump;
        private bool crouch;
        private float h;
        private float v;
        private bool interact;
        private bool fire;

        private void Awake()
        {
            m_Character = GetComponent<PlatformerCharacter2D>();
            platformDepth = GetComponent <PlatformDepth>();
            push = GetComponent<Push>();
            gun = GetComponent<Gun>();
        }


        private void Update()
        {
            if (!m_Jump)
            {
                // Read the jump input in Update so button presses aren't missed.
                m_Jump = CrossPlatformInputManager.GetButtonDown("Jump");
            }
        }


        private void FixedUpdate()
        {
            // Read the inputs.
            crouch = Input.GetKey(KeyCode.LeftControl);
            h = CrossPlatformInputManager.GetAxis("Horizontal");
            v = CrossPlatformInputManager.GetAxis("Vertical");
            interact = CrossPlatformInputManager.GetButton("Jump");
            fire = CrossPlatformInputManager.GetButton("Fire1");

            // Pass all parameters to the character control script.
            if (!platformDepth.IsMoving() && !gun.IsFiring())
            {
                if (!isMoving() && v != 0)
                {
                    if (m_Character.IsGrounded() && platformDepth.Interact(v > 0 ? 1 : -1))
                    {
                        m_Jump = false;
                        return;
                    }
                }

                bool pushing = push.PushPull(interact, m_Character.IsGrounded());
                if (pushing)
                {
                    m_Jump = false;
                    m_Character.Move(h, crouch, m_Jump);
                    return;
                }

                if (fire && !isMoving())
                {
                    gun.Fire();
                    return;
                }

                m_Character.Move(h, crouch, m_Jump);

            }

            m_Jump = false;
        }

        public bool isMoving()
        {
            return !m_Character.IsGrounded() || m_Jump || crouch || h != 0;
        }
    }
}
