﻿using UnityEngine;
using System.Collections;

public class RollRock : MonoBehaviour
{

    public Vector3 force = new Vector3(10, 0, 0);

    public bool rollOnAwake = false;

    private Rigidbody rigidBody;

    private bool startMoving = false;

    void Start()
    {
        rigidBody = GetComponent<Rigidbody>();
        if (rollOnAwake)
        {
            startMoving = true;		
        }
    }

    void Update()
    {
		
        if (startMoving)
        {
            rigidBody.AddForce(force);
            startMoving = false;
        }
    }

    void TriggerMovement()
    {
        rigidBody.isKinematic = false;
        startMoving = true;
    }

    void DoActivateTrigger()
    {
        startMoving = true;
    }

    void OnCollisionEnter(Collision col)
    {
        if (col.gameObject.tag == "Player" && rigidBody.velocity.magnitude > 0.9)
        {
//            col.gameObject.SendMessage("Dead", SendMessageOptions.DontRequireReceiver);
            Application.LoadLevel(Application.loadedLevel);
        }
    }
}
