﻿using UnityEngine;
using System.Collections;

public class SceneState : MonoBehaviour
{

	private static SceneState _instance;

	public static SceneState Instance{ 
		get 
		{ 
			return _instance; 
		} 
	}

	public bool respawn = false;

	private Coroutine coroutine;

	// Use this for initialization
	void Awake ()
	{
		_instance = this;
	}

	void Update()
	{
		if (respawn) {
			if (coroutine == null) {
				coroutine = StartCoroutine (Wait ());
			}
		} else {
			coroutine = null;
		}
	}

	void OnDestroy()
	{
		_instance = null;
	}

	IEnumerator Wait()
	{
		yield return new WaitForSeconds (2);

		respawn = false;
	}
}
