﻿using UnityEngine;
using System.Collections;

public class EnemyMovement : MonoBehaviour
{
	public Transform target;

    public float speed;

    private float startPosition;
    
    private float middle = 0;

    private float targetPos = 0;

    private bool randChosen = false;

    private float move = -1;

    private Rigidbody rigid;

    private bool m_FacingRight = false;

	private float endPosition;

    void Start()
    {
        startPosition = transform.position.x;

		endPosition = target.position.x;

		middle = (startPosition + endPosition) / 2.0f;

        rigid = GetComponent<Rigidbody>();
    }

    void Update()
    {
		
        if (!randChosen)
        {
            randChosen = true;

            if (transform.position.x < middle)
            {
                targetPos = Random.Range(middle + (middle / 2.0f), startPosition);
            }
            else
            {
				targetPos = Random.Range(endPosition, middle - (middle / 2.0f));
            }
        }

        if (randChosen)
        {

            rigid.velocity = new Vector2(move * speed, rigid.velocity.y);

            if (Mathf.Sign(targetPos - transform.position.x) != move)
            {

                if (move > 0)
                {
                    Flip();
                }
                else if (move < 0)
                {
                    Flip();
                }

                randChosen = false;
            }
        }
			
    }

    private void Flip()
    {
        m_FacingRight = !m_FacingRight;
        move = -move;

        Vector3 theScale = transform.localScale;
        theScale.x *= -1;
        transform.localScale = theScale;
    }
}
