﻿using UnityEngine;
using System.Collections;

//falling enemy object
public class EnemyObject : MonoBehaviour
{
    public int damage = 0;

    public float lifeSeconds = 1;

    public bool destroyParent = false;

    private Rigidbody rigidbodyObject;
    private Collider coll;

    void Start()
    {
        rigidbodyObject = GetComponent<Rigidbody>();
        coll = GetComponent<Collider>();

    }

    void OnTriggerEnter(Collider other)
    {		
        if (other.tag == "Player")
        {
            other.BroadcastMessage("Damage", damage, SendMessageOptions.DontRequireReceiver);
//            coll.isTrigger = false;
        }
        else
        {
            rigidbodyObject.isKinematic = true;
            coll.enabled = false;
//            coll.isTrigger = false;
            if (lifeSeconds < 0)
            {
                return;
            }
            StartCoroutine(DestroyAfterSeconds());
        }

    }

    IEnumerator DestroyAfterSeconds()
    {
        yield return new WaitForSeconds(lifeSeconds);

        if (destroyParent)
        {
            SendMessageUpwards("Dead", SendMessageOptions.DontRequireReceiver);
        }
        else
        {
            Destroy(gameObject);
        }
    }
}
