﻿using UnityEngine;
using System.Collections;
using UnityStandardAssets._2D;

public class MovingRock : MonoBehaviour
{

	public Transform rock;
	public Transform endposition;

	private Vector3 startPosition;

	public float animTimeUp = 0.5f;
	public float animTimeDown = 1.5f;

	public float startDelay = 0.5f;
	public float waitSecondsDown = 1;
	public float waitSecondsUp = 0.5f;

	private bool dropped = false;

	private bool init = false;
	private bool tweening = false;

	void Start ()
	{
		startPosition = rock.transform.localPosition;
	}


	void Update ()
	{
		if (dropped) {
			if (!tweening) {
				tweening = true;

				LTDescr tween = LeanTween.moveLocalY (rock.gameObject, startPosition.y, animTimeUp);
				tween.setOnComplete (FinishTweenUp).setOnCompleteParam (false);
			}
		} else {
			
			if (!init) {
				init = true;
				tweening = true;

				LTDescr tween = LeanTween.moveLocalY (rock.gameObject, endposition.localPosition.y, animTimeDown);
				tween.setOnComplete (FinishTweenDown1).setDelay (startDelay);
			} else if (!tweening) {
				
				tweening = true;

				LTDescr tween = LeanTween.moveLocalY (rock.gameObject, endposition.localPosition.y, animTimeDown);
				tween.setOnComplete (FinishTweenDown1);
			}
		}
	}

	void FinishTween (object value)
	{
		dropped = (bool)value;
		tweening = false;
	}

	void FinishTweenDown1 ()
	{
		LeanTween.moveLocalY (rock.gameObject, endposition.localPosition.y + 0.2f, 0.1f).setOnComplete (FinishTweenDown2);
	}

	void FinishTweenDown2 ()
	{
		LeanTween.moveLocalY (rock.gameObject, endposition.localPosition.y, 0.1f).setOnComplete (FinishTweenDown).setOnCompleteParam (true);
	}

	void FinishTweenDown (object value)
	{
		StartCoroutine (Wait ((bool)value, waitSecondsDown));
	}

	void FinishTweenUp (object value)
	{
		StartCoroutine (Wait ((bool)value, waitSecondsUp));
	}

	IEnumerator Wait (bool value, float sec)
	{
		yield return new WaitForSeconds (sec);

		FinishTween (value);
	}

	void DoActivateTrigger()
	{
		GameObject player = GameObject.FindGameObjectsWithTag("Player")[0];
		player.SendMessage ("Dead", SendMessageOptions.DontRequireReceiver);
	}
}
