﻿using UnityEngine;
using System.Collections;

public class Push : MonoBehaviour
{

    private bool push = false;
    private bool hasHandle = false;
    private bool pushStarted = false;

    private FixedJoint distanceJoint;

    private Rigidbody handle;

    void Start()
    {
        distanceJoint = GetComponent<FixedJoint>();
//        distanceJoint.enabled = false;
    }

    void FixedUpdate()
    {
        if (push && hasHandle && !pushStarted)
        {
            pushStarted = true;
            distanceJoint = gameObject.AddComponent<FixedJoint>();
            distanceJoint.connectedBody = handle;
//            distanceJoint.connectedBody = handle;
//            distanceJoint.enabled = true;
//            handle.isKinematic = false;
        }

        if (!push && pushStarted)
        {
            pushStarted = false;
            Destroy(distanceJoint);
//            distanceJoint.enabled = false;
            distanceJoint.connectedBody = null;
//            handle.isKinematic = true;
        }
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.tag == "Handle" && !hasHandle)
        {
            hasHandle = true;
            handle = other.gameObject.GetComponent<Rigidbody>();
        }
    }

    void OnTriggerExit(Collider other)
    {
        if (handle != null && handle.gameObject == other.gameObject)
        {
            hasHandle = false;
        }
    }

    public bool PushPull(bool value, bool grounded)
    {
        push = value && grounded;
        return pushStarted || (push && hasHandle);
    }
}
