﻿using UnityEngine;
using System.Collections;

public class EnemyShoot : MonoBehaviour
{

    public LayerMask hit;
    public float distance;

    private Gun gun;
    private EnemyMovement movement;

    // Use this for initialization
    void Start()
    {
        gun = GetComponent<Gun>();
        movement = GetComponent<EnemyMovement>();
    }
	
    // Update is called once per frame
    void FixedUpdate()
    {
        if (Physics.Raycast(transform.position, transform.right * Mathf.Sign(transform.localScale.x), distance, hit))
        {
            gun.Fire();  
			if (movement != null) {
				movement.enabled = false;
			}
        }
        else
        {
			if (movement != null) {
				movement.enabled = true;
			}
        }
    }
}
