﻿using UnityEngine;
using UnityStandardAssets.CrossPlatformInput;
using System.Collections;

public class Gun : MonoBehaviour
{

    public GameObject bullet;
    public Transform spawnPoint;
    public int count;
    public int maxCount;
    public SpriteRenderer spear;

    private Animator animator;
    private bool firing;

    void Start()
    {
        animator = GetComponent<Animator>();
    }

    void Update()
    {
        if (!firing)
        {
            spear.enabled = count > 0;
        }
    }

    public bool collectBullet()
    {
        if (count < maxCount)
        {
            count++;
            return true;
        }
        return false;
    }

    public void Fire()
    {

        if (count > 0 && !firing)
        {
            firing = true;
            count--;
            animator.SetTrigger("Fire");

        }
    }

    public void FireTrigger()
    {
        Vector3 position = new Vector3(Input.mousePosition.x, Input.mousePosition.y, 10);
        position = Camera.main.ScreenToWorldPoint(position);
        spawnPoint.LookAt(position);
        GameObject b = Instantiate(bullet, spawnPoint.position, Quaternion.identity) as GameObject;
        float angle = Vector2.Angle(Vector2.right, spawnPoint.forward);
        if (spawnPoint.forward.y < 0 && angle <= 90)
        {
            angle = 15;
        }
        if (spawnPoint.forward.y < 0 && angle > 90)
        {
            angle = 165;
        }
        angle = Mathf.Max(angle, 15);
        angle = Mathf.Min(angle, 165);
        b.transform.Rotate(new Vector3(0, 0, angle));
    }

    public void EndFire()
    {
        firing = false;
    }

    public bool IsFiring()
    {
        return firing;
    }

}
